# IRfFrontendLibraryActions Interface Reference

Inherits IUnknown.

List of all members.

## Public Member Functions
HRESULT | PopupMenu ([in] HWND hWnd,[in] POINT pt,[in] UINT nMenu,[in] int nMenuType,[in] IRsNode *pOutlookNode,[in] IRsLibraryItem *pMenuItem,[in] IRsLibrary *pLibrary)
HRESULT | CallAction ([in] int nAction,[in] IRsLibrary *pLibrary,[in] IRsLibraryItem *pLibraryItem)
HRESULT | CreateLibrary ([in] IRnLibraryPlace *pLibraryPlace,[in] POINT *ptDialog)
HRESULT | ImportLibrary ([in] IRnLibraryPlace *pLibraryPlace)
HRESULT | ImportIntoLibrary ([in] IRsLibrary *pLibrary)
HRESULT | ExportFromLibrary ([in] IRsLibraryItem *pLibItem)
HRESULT | OpenLibraryWindow ([in] IRsLibrary *pLibrary)
HRESULT | EditLibraryDescription ([in] IRsLibrary *pLibrary,[in] POINT *ptDialog)
HRESULT | ChangeLibraryIcon ([in] IRsLibrary *pLibrary)
HRESULT | EditLibraryItemDescription ([in] IRsLibraryItem *pLibraryItem,[in] POINT *ptDialog)
HRESULT | RenameLibrary ([in] IRsLibrary *pLibrary,[in] POINT *ptDialog)
HRESULT | ChangeThumbnail ([in] BSTR bstrFilePath)
HRESULT | DeleteLibrary ([in] IRsLibrary *pLibrary)
HRESULT | CreateLibraryPlace ([in] POINT *ptDialog)
HRESULT | CloseLibraryPlace ([in] IRnLibraryPlace *pLibraryPlace)
HRESULT | ShowProperties ([in] IRsLibraryItem *pLibraryItem)
HRESULT | RenameItem ([in] IRsLibraryItem *pLibraryItem,[in] POINT *ptDialog)
HRESULT | DeleteItem ([in] IRsLibraryItem *pLibraryItem)
## Properties
IRsObject * | CustomSelection`[set]`
IRsObject ** | CustomSelection`[get]`

## Detailed Description

The function set allows you to invoke and execute the front-end actions accessible through library menu.

- This function set can be created only through public static method CRpLibrary2::CreateFrontendLibraryActions.

Remarks:
  This object could be changed in future, rather use the CRpLibrary2::CreateRemoteLibraryHelper.

## Member Function Documentation

HRESULT IRfFrontendLibraryActions::PopupMenu | ( | [in] HWND | hWnd,
|  | [in] POINT | pt,
|  | [in] UINT | nMenu,
|  | [in] int | nMenuType,
|  | [in] IRsNode * | pOutlookNode,
|  | [in] IRsLibraryItem * | pMenuItem,
|  | [in] IRsLibrary * | pLibrary |
| ) |  |  |

Invoke library pop-up menu

Parameters:

  | hWnd | [in] Parent window HWND.
  | pt | [in] Position where the menu should appear.
  | nMenu | [in] Resource identification for the desired menu.
  | nMenuType | [in] Sub-menu identification.
  | pOutlookNode | [in] Mapped Outlook node for which the operations from menu are required.
  | pMenuItem | [in] Library item for which the operations are required (where the right click was done).
  | pLibrary | [in] Library for which the menu should be invoked (where the right click was done).

HRESULT IRfFrontendLibraryActions::CallAction | ( | [in] int | nAction,
|  | [in] IRsLibrary * | pLibrary,
|  | [in] IRsLibraryItem * | pLibraryItem |
| ) |  |  |

CallAction. Call this method to execute the popup-menu action

Parameters:

  | nAction | [in] Action identification.
  | pLibrary | [in] Library for which the action is related.
  | pLibraryItem | [in] Library item for which the action is related.

HRESULT IRfFrontendLibraryActions::CreateLibrary | ( | [in] IRnLibraryPlace * | pLibraryPlace,
|  | [in] POINT * | ptDialog |
| ) |  |  |

CreateLibrary. Call to create library in a library place.

Parameters:

  | pLibraryPlace | [in] Library place in which the library should be created.
  | ptDialog | [in] Specify position where the dialog for new library should appears.

HRESULT IRfFrontendLibraryActions::ImportLibrary | ( | [in] IRnLibraryPlace * | pLibraryPlace | ) |

ImportLibrary. Display dialog for library or items selection and execute the import.

Parameters:

  | pLibraryPlace | [in] Library place to which the import should be done..

HRESULT IRfFrontendLibraryActions::ImportIntoLibrary | ( | [in] IRsLibrary * | pLibrary | ) |

ImportIntoLibrary. Opens dialog to choose item(s) to import.

- Execute the import as well after the selection.

Parameters:

  | pLibrary | [in] Library into which the import should be done.

HRESULT IRfFrontendLibraryActions::ExportFromLibrary | ( | [in] IRsLibraryItem * | pLibItem | ) |

ExportFromLibrary. Opens export dialog for the specified library item and allows to export it.

Parameters:

  | pLibItem | [in] Library item to import into library.

HRESULT IRfFrontendLibraryActions::OpenLibraryWindow | ( | [in] IRsLibrary * | pLibrary | ) |

OpenLibraryWindow. Call to open Outlook library window for specified library.

Parameters:

  | pLibrary | [in] Library for which you want open the outlook window.

HRESULT IRfFrontendLibraryActions::EditLibraryDescription | ( | [in] IRsLibrary * | pLibrary,
|  | [in] POINT * | ptDialog |
| ) |  |  |

EditLibraryDescription. Opens dialog for specified library to edit its description

Parameters:

  | pLibrary | [in] Library for which you want open the dialog.
  | ptDialog | [in] Desired position of the dialog in pixels.

HRESULT IRfFrontendLibraryActions::ChangeLibraryIcon | ( | [in] IRsLibrary * | pLibrary | ) |

ChangeLibraryIcon. Opens dialog to change library icon.

Parameters:

  | pLibrary | [in] Library for which you want change the icon.

HRESULT IRfFrontendLibraryActions::EditLibraryItemDescription | ( | [in] IRsLibraryItem * | pLibraryItem,
|  | [in] POINT * | ptDialog |
| ) |  |  |

EditLibraryItemDescription. Opens dialog to change description of the specified library item.

Parameters:

  | pLibraryItem | [in] Library item which you want to change.
  | ptDialog | [in] Desired position of the dialog.

HRESULT IRfFrontendLibraryActions::RenameLibrary | ( | [in] IRsLibrary * | pLibrary,
|  | [in] POINT * | ptDialog |
| ) |  |  |

RenameLibrary. Display dialog to change library name.

Parameters:

  | pLibrary | [in] Library which name you want to change.
  | ptDialog | [in] Desired position of the dialog.

HRESULT IRfFrontendLibraryActions::ChangeThumbnail | ( | [in] BSTR | bstrFilePath | ) |

ChangeThumbnail. Display dialog to change thumbnail for specified file.

Parameters:

  | bstrFilePath | [in] Full file path of the file for which you want change thumbnail.

HRESULT IRfFrontendLibraryActions::DeleteLibrary | ( | [in] IRsLibrary * | pLibrary | ) |

DeleteLibrary. Open yes/no dialog to delete a specific library.

Parameters:

  | pLibrary | [in] Library you want to delete.

HRESULT IRfFrontendLibraryActions::CreateLibraryPlace | ( | [in] POINT * | ptDialog | ) |

CreateLibraryPlace. Opens dialog to create new library place

Parameters:

  | ptDialog | [in] Desired position of the dialog in pixels.

HRESULT IRfFrontendLibraryActions::CloseLibraryPlace | ( | [in] IRnLibraryPlace * | pLibraryPlace | ) |

CloseLibraryPlace. Call to close a library place (close just the outlook window).

Parameters:

  | pLibraryPlace | [in] The library place you want to close.

HRESULT IRfFrontendLibraryActions::ShowProperties | ( | [in] IRsLibraryItem * | pLibraryItem | ) |

ShowProperties. Displays properties for specified library item.

Parameters:

  | pLibraryItem | [in] Library item for which you want display properties dialog.

HRESULT IRfFrontendLibraryActions::RenameItem | ( | [in] IRsLibraryItem * | pLibraryItem,
|  | [in] POINT * | ptDialog |
| ) |  |  |

RenameItem. Displays dialog to change library item name.

Parameters:

  | pLibraryItem | [in] Library item for which you want change the name.
  | ptDialog | [in] Desired position of the dialog.

HRESULT IRfFrontendLibraryActions::DeleteItem | ( | [in] IRsLibraryItem * | pLibraryItem | ) |

DeleteItem. Display yes/no dialog to delete a library item.

Parameters:

  | pLibraryItem | [in] Specify the library item you want to delete.

## Property Documentation

IRsObject * IRfFrontendLibraryActions::CustomSelection`[set]`

CustomSelection. Call to pass the DG objects selection to this front-end library actions.

Parameters:

  | pObj | [in] Objects/nodes selection.

Remarks:
  the fron-end actions use this selection to allow/disable menu items in dialogues and menus.

IRsObject ** IRfFrontendLibraryActions::CustomSelection`[get]`

CustomSelection. Read the current objects selection. Front-end actions could change it by executed actions.

Parameters:

  | ppObj | [out, retval] Returns current front-end objects/nodes selection.